/*******************************************************************************
* File Name: MyKeyPad_KBD_Int.h
* Version 1.60
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/
#if !defined(__MyKeyPad_KBD_Int_INTC_H__)
#define __MyKeyPad_KBD_Int_INTC_H__


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void MyKeyPad_KBD_Int_Start(void);
void MyKeyPad_KBD_Int_StartEx(cyisraddress address);
void MyKeyPad_KBD_Int_Stop(void) ;

CY_ISR_PROTO(MyKeyPad_KBD_Int_Interrupt);

void MyKeyPad_KBD_Int_SetVector(cyisraddress address) ;
cyisraddress MyKeyPad_KBD_Int_GetVector(void) ;

void MyKeyPad_KBD_Int_SetPriority(uint8 priority) ;
uint8 MyKeyPad_KBD_Int_GetPriority(void) ;

void MyKeyPad_KBD_Int_Enable(void) ;
uint8 MyKeyPad_KBD_Int_GetState(void) ;
void MyKeyPad_KBD_Int_Disable(void) ;

void MyKeyPad_KBD_Int_SetPending(void) ;
void MyKeyPad_KBD_Int_ClearPending(void) ;


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the MyKeyPad_KBD_Int ISR. */
#define MyKeyPad_KBD_Int_INTC_VECTOR            ((reg32 *) MyKeyPad_KBD_Int__INTC_VECT)

/* Address of the MyKeyPad_KBD_Int ISR priority. */
#define MyKeyPad_KBD_Int_INTC_PRIOR             ((reg8 *) MyKeyPad_KBD_Int__INTC_PRIOR_REG)

/* Priority of the MyKeyPad_KBD_Int interrupt. */
#define MyKeyPad_KBD_Int_INTC_PRIOR_NUMBER      MyKeyPad_KBD_Int__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable MyKeyPad_KBD_Int interrupt. */
#define MyKeyPad_KBD_Int_INTC_SET_EN            ((reg32 *) MyKeyPad_KBD_Int__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the MyKeyPad_KBD_Int interrupt. */
#define MyKeyPad_KBD_Int_INTC_CLR_EN            ((reg32 *) MyKeyPad_KBD_Int__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the MyKeyPad_KBD_Int interrupt state to pending. */
#define MyKeyPad_KBD_Int_INTC_SET_PD            ((reg32 *) MyKeyPad_KBD_Int__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the MyKeyPad_KBD_Int interrupt. */
#define MyKeyPad_KBD_Int_INTC_CLR_PD            ((reg32 *) MyKeyPad_KBD_Int__INTC_CLR_PD_REG)



/* __MyKeyPad_KBD_Int_INTC_H__ */
#endif
