/*******************************************************************************
* File Name: MyKeyPad_Rows.c  
* Version 1.70
*
* Description:
*  This file contains API to enable firmware control of a Pins component.
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#include "cytypes.h"
#include "MyKeyPad_Rows.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 MyKeyPad_Rows__PORT == 15 && (MyKeyPad_Rows__MASK & 0xC0))

/*******************************************************************************
* Function Name: MyKeyPad_Rows_Write
********************************************************************************
* Summary:
*  Assign a new value to the digital port's data output register.  
*
* Parameters:  
*  prtValue:  The value to be assigned to the Digital Port. 
*
* Return: 
*  void 
*  
*******************************************************************************/
void MyKeyPad_Rows_Write(uint8 value) 
{
    uint8 staticBits = MyKeyPad_Rows_DR & ~MyKeyPad_Rows_MASK;
    MyKeyPad_Rows_DR = staticBits | ((value << MyKeyPad_Rows_SHIFT) & MyKeyPad_Rows_MASK);
}


/*******************************************************************************
* Function Name: MyKeyPad_Rows_SetDriveMode
********************************************************************************
* Summary:
*  Change the drive mode on the pins of the port.
* 
* Parameters:  
*  mode:  Change the pins to this drive mode.
*
* Return: 
*  void
*
*******************************************************************************/
void MyKeyPad_Rows_SetDriveMode(uint8 mode) 
{
	CyPins_SetPinDriveMode(MyKeyPad_Rows_0, mode);
	CyPins_SetPinDriveMode(MyKeyPad_Rows_1, mode);
	CyPins_SetPinDriveMode(MyKeyPad_Rows_2, mode);
	CyPins_SetPinDriveMode(MyKeyPad_Rows_3, mode);
}


/*******************************************************************************
* Function Name: MyKeyPad_Rows_Read
********************************************************************************
* Summary:
*  Read the current value on the pins of the Digital Port in right justified 
*  form.
*
* Parameters:  
*  void 
*
* Return: 
*  Returns the current value of the Digital Port as a right justified number
*  
* Note:
*  Macro MyKeyPad_Rows_ReadPS calls this function. 
*  
*******************************************************************************/
uint8 MyKeyPad_Rows_Read(void) 
{
    return (MyKeyPad_Rows_PS & MyKeyPad_Rows_MASK) >> MyKeyPad_Rows_SHIFT;
}


/*******************************************************************************
* Function Name: MyKeyPad_Rows_ReadDataReg
********************************************************************************
* Summary:
*  Read the current value assigned to a Digital Port's data output register
*
* Parameters:  
*  void 
*
* Return: 
*  Returns the current value assigned to the Digital Port's data output register
*  
*******************************************************************************/
uint8 MyKeyPad_Rows_ReadDataReg(void) 
{
    return (MyKeyPad_Rows_DR & MyKeyPad_Rows_MASK) >> MyKeyPad_Rows_SHIFT;
}


/* If Interrupts Are Enabled for this Pins component */ 
#if defined(MyKeyPad_Rows_INTSTAT) 

    /*******************************************************************************
    * Function Name: MyKeyPad_Rows_ClearInterrupt
    ********************************************************************************
    * Summary:
    *  Clears any active interrupts attached to port and returns the value of the 
    *  interrupt status register.
    *
    * Parameters:  
    *  void 
    *
    * Return: 
    *  Returns the value of the interrupt status register
    *  
    *******************************************************************************/
    uint8 MyKeyPad_Rows_ClearInterrupt(void) 
    {
        return (MyKeyPad_Rows_INTSTAT & MyKeyPad_Rows_MASK) >> MyKeyPad_Rows_SHIFT;
    }

#endif /* If Interrupts Are Enabled for this Pins component */ 

#endif
/* [] END OF FILE */ 
