/*******************************************************************************
* File Name: MyKeyPad_Rows.h  
* Version 1.70
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_MyKeyPad_Rows_H) /* Pins MyKeyPad_Rows_H */
#define CY_PINS_MyKeyPad_Rows_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "MyKeyPad_Rows_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_70 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 MyKeyPad_Rows__PORT == 15 && (MyKeyPad_Rows__MASK & 0xC0))

/***************************************
*        Function Prototypes             
***************************************/    

void    MyKeyPad_Rows_Write(uint8 value) ;
void    MyKeyPad_Rows_SetDriveMode(uint8 mode) ;
uint8   MyKeyPad_Rows_ReadDataReg(void) ;
uint8   MyKeyPad_Rows_Read(void) ;
uint8   MyKeyPad_Rows_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define MyKeyPad_Rows_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define MyKeyPad_Rows_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define MyKeyPad_Rows_DM_RES_UP          PIN_DM_RES_UP
#define MyKeyPad_Rows_DM_RES_DWN         PIN_DM_RES_DWN
#define MyKeyPad_Rows_DM_OD_LO           PIN_DM_OD_LO
#define MyKeyPad_Rows_DM_OD_HI           PIN_DM_OD_HI
#define MyKeyPad_Rows_DM_STRONG          PIN_DM_STRONG
#define MyKeyPad_Rows_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define MyKeyPad_Rows_MASK               MyKeyPad_Rows__MASK
#define MyKeyPad_Rows_SHIFT              MyKeyPad_Rows__SHIFT
#define MyKeyPad_Rows_WIDTH              4u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define MyKeyPad_Rows_PS                     (* (reg8 *) MyKeyPad_Rows__PS)
/* Data Register */
#define MyKeyPad_Rows_DR                     (* (reg8 *) MyKeyPad_Rows__DR)
/* Port Number */
#define MyKeyPad_Rows_PRT_NUM                (* (reg8 *) MyKeyPad_Rows__PRT) 
/* Connect to Analog Globals */                                                  
#define MyKeyPad_Rows_AG                     (* (reg8 *) MyKeyPad_Rows__AG)                       
/* Analog MUX bux enable */
#define MyKeyPad_Rows_AMUX                   (* (reg8 *) MyKeyPad_Rows__AMUX) 
/* Bidirectional Enable */                                                        
#define MyKeyPad_Rows_BIE                    (* (reg8 *) MyKeyPad_Rows__BIE)
/* Bit-mask for Aliased Register Access */
#define MyKeyPad_Rows_BIT_MASK               (* (reg8 *) MyKeyPad_Rows__BIT_MASK)
/* Bypass Enable */
#define MyKeyPad_Rows_BYP                    (* (reg8 *) MyKeyPad_Rows__BYP)
/* Port wide control signals */                                                   
#define MyKeyPad_Rows_CTL                    (* (reg8 *) MyKeyPad_Rows__CTL)
/* Drive Modes */
#define MyKeyPad_Rows_DM0                    (* (reg8 *) MyKeyPad_Rows__DM0) 
#define MyKeyPad_Rows_DM1                    (* (reg8 *) MyKeyPad_Rows__DM1)
#define MyKeyPad_Rows_DM2                    (* (reg8 *) MyKeyPad_Rows__DM2) 
/* Input Buffer Disable Override */
#define MyKeyPad_Rows_INP_DIS                (* (reg8 *) MyKeyPad_Rows__INP_DIS)
/* LCD Common or Segment Drive */
#define MyKeyPad_Rows_LCD_COM_SEG            (* (reg8 *) MyKeyPad_Rows__LCD_COM_SEG)
/* Enable Segment LCD */
#define MyKeyPad_Rows_LCD_EN                 (* (reg8 *) MyKeyPad_Rows__LCD_EN)
/* Slew Rate Control */
#define MyKeyPad_Rows_SLW                    (* (reg8 *) MyKeyPad_Rows__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define MyKeyPad_Rows_PRTDSI__CAPS_SEL       (* (reg8 *) MyKeyPad_Rows__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define MyKeyPad_Rows_PRTDSI__DBL_SYNC_IN    (* (reg8 *) MyKeyPad_Rows__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define MyKeyPad_Rows_PRTDSI__OE_SEL0        (* (reg8 *) MyKeyPad_Rows__PRTDSI__OE_SEL0) 
#define MyKeyPad_Rows_PRTDSI__OE_SEL1        (* (reg8 *) MyKeyPad_Rows__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define MyKeyPad_Rows_PRTDSI__OUT_SEL0       (* (reg8 *) MyKeyPad_Rows__PRTDSI__OUT_SEL0) 
#define MyKeyPad_Rows_PRTDSI__OUT_SEL1       (* (reg8 *) MyKeyPad_Rows__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define MyKeyPad_Rows_PRTDSI__SYNC_OUT       (* (reg8 *) MyKeyPad_Rows__PRTDSI__SYNC_OUT) 


#if defined(MyKeyPad_Rows__INTSTAT)  /* Interrupt Registers */

    #define MyKeyPad_Rows_INTSTAT                (* (reg8 *) MyKeyPad_Rows__INTSTAT)
    #define MyKeyPad_Rows_SNAP                   (* (reg8 *) MyKeyPad_Rows__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins MyKeyPad_Rows_H */

#endif
/* [] END OF FILE */
